package com.memorynotfound.springboot;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

@SpringBootApplication
public class Application implements CommandLineRunner {

    private static Logger log = LoggerFactory.getLogger(Application.class);

    @Autowired
    private MusicService musicService;

    public static void main(String[] args) throws Exception {
        SpringApplication.run(Application.class, args);
    }

    @Override
    public void run(String... args) throws Exception {
        log.info("Spring Boot Conditional Caching and Other Caching Annotations Example");

        String service = MusicServiceIml.class.getSimpleName();
        log.info("Calling: " + service + ".findAll();");
        log.info("Occurrences: " + musicService.findAll());
        log.info("Calling: " + service + ".findAll();");
        log.info("Occurrences: " + musicService.findAll());
        log.info("Calling: " + service + ".findByIndex();");
        musicService.findByIndex(1);
        log.info("Calling: " + service + ".findByIndex();");
        musicService.findByIndex(1);
        log.info("Calling: " + service + ".findByIndex();");
        musicService.findByIndex(0);
        log.info("Calling: " + service + ".findByIndex();");
        musicService.findByIndex(0);
        log.info("Calling: " + service + ".save();");
        musicService.save("Saxophone");
        log.info("Calling: " + service + ".findAll();");
        log.info("Occurrences: " + musicService.findAll());
        log.info("Calling: " + service + ".delete();");
        musicService.delete("Bass");
        log.info("Calling: " + service + ".findAll();");
        log.info("Occurrences: " + musicService.findAll());
        log.info("Calling: " + service + ".deleteAll();");
        musicService.deleteAll();
        log.info("Calling: " + service + ".findAll();");
        log.info("Occurrences: " + musicService.findAll());

        play("trombone");
        play("guitar");
        play("trombone");
        play("bass");
        play("trombone");
    }

    private void play(String instrument){
        log.info("Calling: " + MusicServiceIml.class.getSimpleName() + ".play(\"" + instrument + "\");");
        musicService.play(instrument);
    }
}
